			$MOD51
		$TITLE(PIR ALARM SYSTEM)

;----------------------------------------------------------------------

sensor		bit	p3.3
led1		bit	p3.2      ;indikator sensor
led2		bit	p3.4	  ;indikator alarm 
led3		bit	p3.5	  ;indikator jumlah orang
temp		equ	21h
counter		equ	22h
DISPLAY		equ	23h
hitung		equ	24h

Write           EQU     0700H
InitLCD         EQU     0740H
CommandLCD      EQU     07B0H
WriteLCD        EQU     07D0H
ReadLCD         EQU     07F0H
ReadAddrLCD     EQU     0820H
SetDDRAM        EQU     0850H
SetCGRAM        EQU     0870H

DisplayClear    EQU	01H

		ORG 	4000h
		AJMP 	Start
	
		org 	400bh
		inc	temp
		MOV	A,temp
		CJNE	A,#200,exit
		inc 	counter
		mov	temp,#0
exit:		reti

		ORG 	4100h		

;----------------------------------------------------------------------

Start:		mov	p1,#0ffh
		mov	sp,#40h
		LCALL	InitLCD
		MOV	A,#00H
		LCALL	SetDDRAM
		MOV	A,#'J'
		LCALL	WriteLCD
		MOV	A,#'U'
		LCALL	WriteLCD
		MOV	A,#'M'
		LCALL	WriteLCD
		MOV	A,#'L'
		LCALL	WriteLCD
		MOV	A,#'A'
		LCALL	WriteLCD
		MOV	A,#'H'
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		MOV	A,#'O'
		LCALL	WriteLCD
		MOV	A,#'R'
		LCALL	WriteLCD
		MOV	A,#'A'
		LCALL	WriteLCD
		MOV	A,#'N'
		LCALL	WriteLCD
		MOV	A,#'G'
		LCALL	WriteLCD
		MOV	A,#':'
		LCALL	WriteLCD
		MOV	A,#41H
		LCALL	SetDDRAM
		MOV	A,#'0'
		LCALL	WriteLCD
		MOV	A,#'0'
		LCALL	WriteLCD
		MOV	A,#'0'
		LCALL	WriteLCD
		MOV	A,#' '
		LCALL	WriteLCD
		MOV	A,#'O'
		LCALL	WriteLCD
		MOV	A,#'R'
		LCALL	WriteLCD
		MOV	A,#'A'
		LCALL	WriteLCD
		MOV	A,#'N'
		LCALL	WriteLCD
		MOV	A,#'G'
		LCALL	WriteLCD
		CLR	led1
		CLR	led2
		CLR	led3
		MOV	TMOD,#00000010b	;t0 counter 8 bit autoreload
		MOV	TH0,#00h
		SETB	EA
		SETB	ET0
		mov	DISPLAY,#00h
		mov	HITUNG,#00h

		
AWAL:		CLR	TR0
		MOV	Counter,#0
		MOV	temp,#0
		MOV	TL0,#00h
		JNB	sensor,$
		SETB	led1
		SETB	TR0
		JB	sensor,$
		CLR	led1
		CLR	TR0
		MOV	A,counter
		CJNE	A,#8,cek	;CEK WAKTU
cek:		JC	awal			
		SETB	led2
		MOV	A,#41H
		LCALL	SetDDRAM
		inc	DISPLAY
		inc	hitung
		mov	a,DISPLAY
		mov	b,#100
		div	ab
		add	a,#30h
		LCALL	WriteLCD
		mov	a,b
		Mov	b,#10
		div	ab
		add	a,#30h
		LCALL	WriteLCD
		mov	a,b
		add	a,#30h
		LCALL	WriteLCD
		mov	a,HITUNG
		cjne	a,#5,terus	;CEK JML ORANG
		mov	HITUNG,#00h
		setb	led3
terus:		acall	delay
		clr	led2
		clr	led3
		AJMP	awal
;----------------------------------------------------------------------
DELAY:	
		MOV	R7,#6
DEL1:		MOV	R6,#0FFh
DEL2:		MOV	R5,#0FFh
		DJNZ	R5,$
		DJNZ	R6,DEL2
		DJNZ	R7,DEL1				
		ret

			end